"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAllCorrectResponses = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _forEach = _interopRequireDefault(require("lodash/forEach"));

var getAllCorrectResponses = function getAllCorrectResponses(_ref) {
  var choices = _ref.choices,
      alternateResponse = _ref.alternateResponse;
  alternateResponse = alternateResponse || {};
  var correctAnswers = {};
  (0, _forEach["default"])(choices, function (respArea, key) {
    if (!correctAnswers[key]) {
      correctAnswers[key] = [];
    }

    if (respArea) {
      respArea.forEach(function (choice) {
        if (choice.correct) {
          correctAnswers[key].push(choice.value);

          if (alternateResponse[key]) {
            correctAnswers[key] = [].concat((0, _toConsumableArray2["default"])(correctAnswers[key]), (0, _toConsumableArray2["default"])(alternateResponse[key]));
          }
        }
      });
    }
  });
  return correctAnswers;
};

exports.getAllCorrectResponses = getAllCorrectResponses;
//# sourceMappingURL=utils.js.map