"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.InlineDropdown = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _correctAnswerToggle = require("@pie-lib/pie-toolbox/correct-answer-toggle");

var _maskMarkup = require("@pie-lib/pie-toolbox/mask-markup");

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

var _mathRendering = require("@pie-lib/pie-toolbox/math-rendering");

var _styles = require("@material-ui/core/styles");

var _classnames = _interopRequireDefault(require("classnames"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var InlineDropdown = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(InlineDropdown, _React$Component);

  var _super = _createSuper(InlineDropdown);

  function InlineDropdown() {
    var _this;

    (0, _classCallCheck2["default"])(this, InlineDropdown);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      showCorrectAnswer: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleShowCorrect", function () {
      _this.setState({
        showCorrectAnswer: !_this.state.showCorrectAnswer
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(InlineDropdown, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if ((0, _isEmpty["default"])(nextProps.feedback)) {
        this.setState({
          showCorrectAnswer: false
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      // eslint-disable-next-line
      var domNode = _reactDom["default"].findDOMNode(this);

      (0, _mathRendering.renderMath)(domNode);
    }
  }, {
    key: "render",
    value: function render() {
      var showCorrectAnswer = this.state.showCorrectAnswer;
      var _this$props = this.props,
          classes = _this$props.classes,
          prompt = _this$props.prompt,
          mode = _this$props.mode,
          model = _this$props.model,
          rationale = _this$props.rationale,
          teacherInstructions = _this$props.teacherInstructions,
          choices = _this$props.choices,
          displayType = _this$props.displayType,
          language = _this$props.language;

      var _ref = model || {},
          extraCSSRules = _ref.extraCSSRules;

      var showCorrectAnswerToggle = mode === 'evaluate';
      var choiceRationalesHaveText = false;
      var showRationale = rationale && ((0, _renderUi.hasText)(rationale) || (0, _renderUi.hasMedia)(rationale));
      var showTeacherInstructions = teacherInstructions && ((0, _renderUi.hasText)(teacherInstructions) || (0, _renderUi.hasMedia)(teacherInstructions));
      var choiceRationales = (Object.keys(choices) || []).map(function (key) {
        return (choices[key] || []).reduce(function (acc, currentValue) {
          if (currentValue.rationale && (0, _renderUi.hasText)(currentValue.rationale)) {
            choiceRationalesHaveText = true;
            acc.push(currentValue);
          }

          return acc;
        }, []);
      });
      return /*#__PURE__*/_react["default"].createElement(_renderUi.UiLayout, {
        extraCSSRules: extraCSSRules,
        className: classes.mainContainer,
        style: {
          display: "".concat(displayType)
        }
      }, mode === 'gather' && /*#__PURE__*/_react["default"].createElement("h2", {
        className: classes.srOnly
      }, "Inline Dropdown Question"), showTeacherInstructions && /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        className: classes.collapsible,
        labels: {
          hidden: 'Show Teacher Instructions',
          visible: 'Hide Teacher Instructions'
        }
      }, /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        prompt: teacherInstructions
      })), prompt && /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        prompt: prompt
      }), /*#__PURE__*/_react["default"].createElement(_correctAnswerToggle.CorrectAnswerToggle, {
        show: showCorrectAnswerToggle,
        toggled: showCorrectAnswer,
        onToggle: this.toggleShowCorrect,
        language: language
      }), /*#__PURE__*/_react["default"].createElement(_maskMarkup.InlineDropdown, (0, _extends2["default"])({}, this.props, {
        showCorrectAnswer: showCorrectAnswer
      })), choiceRationalesHaveText && /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        className: classes.collapsible,
        labels: {
          hidden: 'Show Rationale for choices',
          visible: 'Hide Rationale for choices'
        }
      }, choiceRationales.map(function (choices, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: classes.choiceRationaleWrapper
        }, (choices === null || choices === void 0 ? void 0 : choices.length) > 0 && choices.map(function (choice) {
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: classes.choiceRationale,
            key: choice.label
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: (0, _classnames["default"])(classes.choiceRationaleLabel, choice.correct ? 'correct' : 'incorrect'),
            dangerouslySetInnerHTML: {
              __html: "".concat(choice.label, ": ")
            }
          }), /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
            prompt: choice.rationale
          }));
        }));
      })), showRationale && /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        labels: {
          hidden: 'Show Rationale',
          visible: 'Hide Rationale'
        }
      }, /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        prompt: rationale
      })));
    }
  }]);
  return InlineDropdown;
}(_react["default"].Component);

exports.InlineDropdown = InlineDropdown;
(0, _defineProperty2["default"])(InlineDropdown, "propTypes", {
  classes: _propTypes["default"].object,
  prompt: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  markup: _propTypes["default"].string,
  mode: _propTypes["default"].string,
  displayType: _propTypes["default"].string,
  rationale: _propTypes["default"].string,
  teacherInstructions: _propTypes["default"].string,
  model: _propTypes["default"].object.isRequired,
  choices: _propTypes["default"].object,
  value: _propTypes["default"].object,
  feedback: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  language: _propTypes["default"].string
});
(0, _defineProperty2["default"])(InlineDropdown, "defaultProps", {
  value: {}
});

var styles = function styles(theme) {
  return {
    mainContainer: {
      color: _renderUi.color.text(),
      backgroundColor: _renderUi.color.background()
    },
    collapsible: {
      marginBottom: theme.spacing.unit * 2
    },
    choiceRationaleWrapper: {
      '&:not(:last-child)': {
        marginBottom: theme.spacing.unit * 2
      }
    },
    choiceRationale: {
      display: 'flex',
      whiteSpace: 'break-spaces'
    },
    choiceRationaleLabel: {
      display: 'flex',
      '&.correct': {
        color: _renderUi.color.correct()
      },
      '&.incorrect': {
        color: _renderUi.color.incorrectWithIcon()
      }
    },
    srOnly: {
      position: 'absolute',
      left: '-10000px',
      top: 'auto',
      width: '1px',
      height: '1px',
      overflow: 'hidden'
    }
  };
};

var _default = (0, _styles.withStyles)(styles)(InlineDropdown);

exports["default"] = _default;
//# sourceMappingURL=inline-dropdown.js.map